function rpGame(){
	var self = this;
	self.connected=false;
	self.wsclose=false;
	self.loadNum=0;
	self.showMessage=function(msg){
		var oldMsg=$('.rpMessage').html();
		$('.rpMessage').html(msg+'<br>'+oldMsg);
	}
	self.hideMessage=function(){
		$('.rpMessage').html('');
	}
	self.showSpeed=function(speed){
		$('.rplay input[name=rpSpeed]').val(speed);
	}
	this.rpSocket=function (){
		var ws = new WebSocket(gameServer);
		ws.onopen = function () {
			self.sendMsg({'action':'connection','gameToken':gameToken,'langIso':gameLangIso});
			self.connected=true;
		};
		ws.onmessage = function (e) {
			var rs = e.data?JSON.parse(e.data):[];
			if(rs.errorCode){
				self.showMessage(rs.errorMessage);
			}
			if(rs.serverConnection){
				var product=rs.product;
				self.showSpeed(product.speed);
				self.showMessage('Successfully connected.');
			}
			if(rs.action=='setSpeed'){
				self.showSpeed(rs.speed);
			}
			if(rs.offline==1){
				self.showMessage(gameLangOver);
			}
		};
		ws.onerror = function (e) {
			if(ws.readyState==3){
				self.showMessage(gameLangConnectionFailed+';');
			}
		};
		ws.onclose=function(){
			if(self.connected){
				self.showMessage(gameLangOver);
			}else{
				self.showMessage(gameLangConnectionFailed);
			}
			self.wsclose=true;
		};
		$(window).on('beforeunload',function(){
			self.sendMsg({'action':'close'});
		});
		$(window).on('unload',function(){
			self.sendMsg({'action':'close'});
		});
		self.sendMsg=function(msg){
			if(ws.readyState==1) ws.send(JSON.stringify(msg));
		}
		self.connectingMessage=window.setInterval(function(){
			var s='.';
			if(self.loadNum>3) self.loadNum=0;
			if(self.connected||self.wsclose){ 
				window.clearInterval(self.connectingMessage);
				return;
			}
			self.showMessage(gameLangConnecting+s.repeat(self.loadNum));
			self.loadNum++;
		},500);
	}
}